/////////////////////////////////////////////////////////////////////////////// 
// 
// PagTest.cc 
// ------------- 
// Pager class test module 
// 
// Design and Implementation by Bjoern Lemke 
// 
// (C)opyright 2017 by Bjoern Lemke 
// 
// 
/////////////////////////////////////////////////////////////////////////////// 

#include "../src/Exception.h" 
#include "../src/Pager.h" 

#include <locale.h> 

class MyPager : public Pager
{
    
public:
    
    MyPager(const Chain& title) : Pager(title) {
	
    }
    
    ~MyPager() {
    }
    
    bool execute(const Chain& cmd, Chain& msg) {

	if ( cmd == Chain("ok") )
	{
	    msg = Chain("All is ok : ") + cmd;
	    return true;
	}
	else
	{
	    msg = Chain("Here comes the very log error message with several words <") + cmd + Chain(">");
	    return false;	    
	}
    }
    
    ListT<Chain> getSchema() { 

	ListT<Chain> schema;

	schema.Insert("First:30");
	schema.Insert("SecondColumn:auto");
	schema.Insert("Third:10");

	return schema;

    }

    ListT< ListT<Chain> > getData() {

	
	ListT< ListT<Chain> > outData; 
	
        for ( int i=1; i<= 67; i++) 
        { 
             ListT<Chain> outRow;
             outRow.Insert(Chain(i) + Chain(" Alpha") ); 
             outRow.Insert(Chain("Beta") + Chain(i) + Chain("BetaX")); 
             outRow.Insert("Gamma1Gamma2\nGamma3"); 
             outData.Insert(outRow); 
        }

	return outData;

    }
   
private:
            
};


int main(int argc, char **argv) 
{ 
    try 
    { 
     	   
	MyPager pag(Chain("The Page"));
	
	pag.manage();

    } 
    catch (Exception e) 
    { 
        Chain msg; 
        e.pop(msg); 
        cout << msg << endl; 
        return 1; 
    } 

    return 0; 

} 
